<?php
ini_set('display_errors', 1);


require_once '../../../resources/base_path_include.php';

require_once $base_path_to_resources . "includes/config.php"; // use require for mandatory files
require_once $base_path_to_resources . 'lib/function.php';
require_once $base_path_to_resources . "lib/currency_functions.php";
require_once $base_path_to_resources . 'lib/validate_api_signature.php';
require_once $base_path_to_resources . 'lib/validate_function.php';

//valdation file
require_once $base_path . 'user_management/authenticate.php';
require_once $base_path . 'modules/accounting/groups_ledgers/functions/ledger_functions.php';
require_once $base_path . 'modules/accounting/book_management/basic_book_info_function.php';
require_once $base_path . 'modules/accounting/functions/basic_balance_function.php';
//creating dynamic db
require_once $base_path_to_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);die();
// checkIfNoPhpContentsReceive();

if ( !isset($postdata['company_id']) or !checkIfIssetAndNotEmpty($postdata['company_id']) or
!isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or 
!isset($postdata['book_id']) or !checkIfIssetAndNotEmpty($postdata['book_id']) or 
!isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
!isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All fields are required .");
}

validateApiSignature($postdata['api_signature']);
//authenticate jwt token
$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is decoded in data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$role = $jwt_validate->data->role;
$username = $jwt_validate->data->username;

$function_type = $postdata['function_type'];

if ($function_type  == "fetch_ledgers") {

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $company_id = trim($postdata['company_id']);
    $branch_id = trim($postdata['branch_id']);
    $book_id = trim($postdata['book_id']);

    //$export_type = trim($postdata['export_type']);
     $function_code = $postdata['function_type'];

    $confirmed_role_user = validatePrimaryAccess($conn, $workspace_id, $role, $userid, ['superadmin', 'admin', null]);
    if (!$confirmed_role_user){ 
        errorreturn('Access denied.');
    }else{
        $specific_db_conn = dynamicDbConnection($confirmed_role_user);
         if ($role == null) {
            checkCompanyBranchFunctionAccess($specific_db_conn, $role, $userid, $workspace_id, $company_id, $branch_id, $book_id,  $function_code);
         }
    }
    $export_type = (isset($postdata['export_type']) and !empty($postdata['export_type'])) ? ($postdata['export_type']) : null;

    $book_info = GetBasicBook($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id);
    $book_name = $book_info['book_basic_info']['book_name'];
    $book_opening_date = $book_info['book_basic_info']['book_opening_date'];
    $book_closing_date = $book_info['book_basic_info']['book_closing_date'];

   

    $additionaldata = array();
    $additionaldata = ['id', 'ledger_name', 'ledger_current_bal'];
    $additionaldata = array_merge($additionaldata, $postdata['additional_data']);

    //$limit = $postdata['limit'];

    $limit = (isset($postdata['limit']) and !empty($postdata['limit'])) ? trim($postdata['limit']) : null;

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {

        $offset = null;
    }

    if (isset($export_type)) { // true // value check should either be spreadsheet pdf 
        if ($export_type == 'spreadsheet') {

             require_once $base_path . 'modules/accounting/groups_ledgers/export/manage_ledgers/excel/export_manage_ledgers_excel.php';
        } else  if ($export_type == 'pdf') {

        require_once $base_path . 'modules/accounting/groups_ledgers/export/manage_ledgers/pdf/export_manage_ledgers_pdf.php';
           
        }
        else  if ($export_type == 'print') {

        require_once $base_path . 'modules/accounting/groups_ledgers/export/manage_ledgers/print/export_manage_ledgers_print.php';
           
        }
    } else {

        if ($limit != 'all') {
            $offset = ($page - 1) * $limit;

            $success['data'] = getLedger($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id, $search_string, $limit, $offset, $additionaldata);
            successreturn($success);
        } else {

            $success['data'] = getLedger($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id, $search_string, $limit, null, $additionaldata);
            successreturn($success);
        }
    }
}
